package eu.jonahbauer.survey.controller.survey;

import eu.jonahbauer.survey.persistence.entity.Answer;
import eu.jonahbauer.survey.persistence.entity.AnswerEvaluation;
import eu.jonahbauer.survey.persistence.entity.Question;
import eu.jonahbauer.survey.persistence.entity.Survey;
import eu.jonahbauer.survey.persistence.repository.SurveyRepository;
import lombok.AccessLevel;
import lombok.Getter;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;

@Controller
@Getter(AccessLevel.PRIVATE)
@RequiredArgsConstructor
public class SurveyEvaluationController {
    private final SurveyRepository surveyRepository;

    @GetMapping("/survey/{id}/evaluate")
    public String get(@PathVariable int id, Model model) {
        Survey survey = getSurveyRepository().findEvaluationById(id);

        long sub = getSurveyRepository().getSubmissionCountById(survey.getId());

        for (Question question : survey.getQuestions()) {
            for (Answer answer : question.getAnswers()) {
                AnswerEvaluation evaluation = answer.getEvaluation();
                long count = evaluation.getCount();

                var percentage = sub > 0 ? count * 100d / sub : 0;
                evaluation.setPercentage(percentage);
                evaluation.setBarPercentage(percentage);
            }
        }

        model.addAttribute("survey", survey);
        return "survey/evaluation";
    }
}
