package eu.jonahbauer.survey.model;

import eu.jonahbauer.survey.validation.constraints.Password;
import jakarta.validation.constraints.NotNull;
import jakarta.validation.constraints.Pattern;
import lombok.Data;
import org.hibernate.validator.constraints.Length;

@Data
public final class RegistrationForm {
    @NotNull(message = "{registration.username.not_null}")
    @Length(min = 4, max = 255, message = "{registration.username.length}")
    @Pattern(regexp = "[a-zA-Z0-9_]*", message = "{registration.username.pattern}")
    private String username;

    @NotNull(message = "{registration.password.not_null}")
    @Length(min = 8, max = 255, message = "{registration.password.length}")
    @Password(message = "{registration.password.password}")
    private String password;
}
