package eu.jonahbauer.survey.persistence.entity;

import jakarta.persistence.*;
import jakarta.validation.constraints.NotNull;
import lombok.Data;
import org.hibernate.annotations.Immutable;

/**
 * A database view showing how often an {@link Answer} has been selected.
 */
@Entity
@Data
@Table(name = "answer_evaluation")
@Immutable
public class AnswerEvaluation {
    @Id
    @Column(name = "answer", nullable = false)
    private Integer answer;

    @Column(name = "count", nullable = false)
    @NotNull
    private Long count;

    @Transient
    private transient Double percentage;

    @Transient
    private transient Double barPercentage;
}
