package eu.jonahbauer.survey.spring;

import org.springframework.boot.web.server.MimeMappings;
import org.springframework.boot.web.server.WebServerFactoryCustomizer;
import org.springframework.boot.web.servlet.server.ConfigurableServletWebServerFactory;
import org.springframework.context.annotation.Configuration;

@Configuration
public class MimeTypeConfig implements WebServerFactoryCustomizer<ConfigurableServletWebServerFactory> {
    @Override
    public void customize(ConfigurableServletWebServerFactory factory) {
        MimeMappings mappings = new MimeMappings(MimeMappings.DEFAULT);
        mappings.add("woff", "application/font-woff");
        mappings.add("woff2", "application/font-woff2");
        mappings.add("ttf", "application/x-font-truetype");
        mappings.add("eot", "application/vnd.ms-fontobject");
        mappings.add("svg", "image/svg+xml");
        mappings.add("otf", "application/x-font-opentype");
        factory.setMimeMappings(mappings);
    }
}
