package eu.jonahbauer.survey.validation;

import eu.jonahbauer.survey.validation.constraints.Password;
import jakarta.validation.ConstraintValidator;
import jakarta.validation.ConstraintValidatorContext;

public class PasswordValidator implements ConstraintValidator<Password, String> {

    @Override
    public boolean isValid(String value, ConstraintValidatorContext context) {
        if (value == null) return true;

        boolean lowercase = false;
        boolean uppercase = false;
        boolean digit = false;
        boolean special = false;

        for (char c : value.toCharArray()) {
            if (Character.isLowerCase(c)) {
                lowercase = true;
            } else if (Character.isUpperCase(c)) {
                uppercase = true;
            } else if (Character.isDigit(c)) {
                digit = true;
            } else {
                special = true;
            }
        }

        return lowercase && uppercase && digit && special;
    }
}
